<template>
<div class="wrapper">
  <div class="box">
    <div class="header">
      <app-logo/>
    </div>

    <div class="social-buttons">
      <auth-button
      :buttonType="'twitter'"
      :buttonValue="twitterLoginText"/>

      <!-- <auth-button
      :buttonType="'facebook'"
      :buttonValue="facebookLoginText"/>

      <auth-button
      :buttonType="'google'"
      :buttonValue="googleLoginText"/> -->
    </div>

    <p>or</p>

    <form class="login-form"
    @submit="onFormSubmit"
    method="post">
      <app-input :type="'email'"
      :placeholder="'Email'"
      :value="email"
      @input="onEmailInput"/>
      <app-input v-if="!isLogin"
      :type="'text'"
      :placeholder="'Nickname'"
      :value="nickname"
      @input="onNicknameInput"/>
      <app-input :type="'password'"
      :placeholder="'Password'"
      :value="password"
      @input="onPasswordInput"/>

      <router-link v-if="isLogin"
      class="link"
      :to="{}">
        I forgot my password
      </router-link>


      <app-error v-for="(error, index) in errors"
      :key="index"
      :text="error"/>

      <div v-if="!isLoading">
        <auth-button v-if="isLogin"
        class="auth-button"
        type="submit"
        :buttonType="'login'"
        :buttonValue="'LOG IN'"
        :isDisabled="isAuthButtonDisabled"
        />

        <auth-button v-else
        class="auth-button"
        type="submit"
        :buttonType="'signup'"
        :buttonValue="'SIGN UP'"
        :isDisabled="isAuthButtonDisabled"
        />
      </div>

      <font-awesome-icon v-if="isLoading"
      :icon="iconSpinner"
      size="lg"
      spin/>
    </form>
  </div>

  <!-- Text under the box -->
  <div v-if="isLogin"
  class="sign-up-in-link">
    Don't have an account?
    <router-link class="link"
    :to="{ name: 'Signup' }">
      Sign up!
    </router-link>
  </div>
  <div v-else
  class="sign-up-in-link">
    Already have an account?
    <router-link class="link"
    :to="{ name: 'Login' }">
      Log In
    </router-link>
  </div>
</div>
</template>

<script>
import AuthService from '@/mixins/AuthService';

import AppLogo from '@/components/AppLogo';
import AuthButton from '@/components/AuthButton';
import AppInput from '@/components/AppInput';
import AppError from '@/components/AppError';
import FontAwesomeIcon from '@fortawesome/vue-fontawesome';

import faSpinner from '@fortawesome/fontawesome-free-solid/faSpinner';

export default {
  name: 'TheAuth',
  mixins: [AuthService],
  components: {
    AppLogo,
    AuthButton,
    AppInput,
    AppError,
    FontAwesomeIcon,
  },
  data() {
    return {
      email: '',
      password: '',
      nickname: '',
      errors: [],
      isLoading: false,
    };
  },
  computed: {
    iconSpinner() {
      return faSpinner;
    },
    isLogin() {
      return this.$route.name === 'Login';
    },
    twitterLoginText() {
      return this.isLogin ? '(TODO) LOG IN WITH TWITTER' : '(TODO) SIGN UP WITH TWITTER';
    },
    facebookLoginText() {
      return this.isLogin ? '(TODO) LOG IN WITH FACEBOOK' : '(TODO) SIGN UP WITH FACEBOOK';
    },
    googleLoginText() {
      return this.isLogin ? '(TODO) LOG IN WITH GOOGLE' : '(TODO) SIGN UP WITH GOOGLE';
    },
    isAuthButtonDisabled() {
      return Boolean(!this.password.length || !this.email.length);
    },
  },
  methods: {
    onEmailInput(newValue) {
      this.email = newValue;
    },
    onNicknameInput(newValue) {
      this.nickname = newValue;
    },
    onPasswordInput(newValue) {
      this.password = newValue;
    },
    async onFormSubmit(e) {
      e.preventDefault();
      if (!this.isAuthButtonDisabled) {
        this.errors = [];
        try {
          this.isLoading = true;
          await this.createUser(this.email, this.password);
          this.isLoading = false;
        } catch (error) {
          this.isLoading = false;
          this.errors.push(error.message);
          console.log(error);
        }
      }
    },
  },
};
</script>

<style lang="scss" scoped>
@import '~styles/colors.scss';

.box {
  margin: auto;
  padding: 0 0 0.1em 0;
  width: 320px;

  background-color: white;
  border-radius: 0.4em;
  box-shadow: rgba(0, 0, 0, 0.4) 0px 10px 20px -10px;
}

.header {
  height: 100px;
  margin-bottom: 1em;

  display: flex;
  justify-content: center;
  align-items: center;

  border-radius: 0.4em 0.4em 0 0;

  background: linear-gradient(135deg, $gradient-left 0%,$gradient-right 100%);
}

.login-form {
  margin: 1em 0;
}

.link {
  font-weight: 600;
  text-decoration: none;
  color: $text-primary;
}

.auth-button {
  margin: 1em 0;
}

.sign-up-in-link {
  margin: 1em 0;
}

@media screen and (max-width: 768px) {
  .header {
    display: none;
  }
}
</style>
